# -*- coding: utf-8 -*-
#Библиотеки, които използват python и Kodi в тази приставка
import re
import sys
import os
import urllib
import urllib2
import xbmc
import xbmcgui
import xbmcplugin
import xbmcaddon
import json

#Място за дефиниране на константи, които ще се използват няколкократно из отделните модули
__addon_id__= 'plugin.video.tubi'
__Addon = xbmcaddon.Addon(__addon_id__)
searchicon = xbmc.translatePath(__Addon.getAddonInfo('path') + "/resources/search.png")
srtsubs_path = xbmc.translatePath('special://temp/tubi.English.srt')

MUA = 'Mozilla/5.0 (Linux; Android 5.0.2; bg-bg; SAMSUNG GT-I9195 Build/JDQ39) AppleWebKit/535.19 (KHTML, like Gecko) Version/1.0 Chrome/18.0.1025.308 Mobile Safari/535.19' #За симулиране на заявка от мобилно устройство
UA = 'Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0' #За симулиране на заявка от  компютърен браузър


#Категории на съдържанието
def CATEGORIES():
        req = urllib2.Request('http://tubitv.com/oz/categories/')
        req.add_header('User-Agent', UA)
        req.add_header('Referer', 'https://tubitv.com/')
        opener = urllib2.build_opener()
        f = opener.open(req)
        jsonrsp = json.loads(f.read())
        #print jsonrsp[0]['title']
        #print jsonrsp[0]['id']
        
        addDir('Search','http://tubitv.com/oz/search/',2,searchicon)
        try:
            for categories in range(0, len(jsonrsp)):
                addDir(jsonrsp[categories]['title'],jsonrsp[categories]['id'],1,'DefaultFolder.png')
        except:
            pass
        #addDir('','',1,'DefaultFolder.png')


#Разлистване заглавията от отделните категории
def INDEXCONTENT(url):
        req = urllib2.Request('http://tubitv.com/oz/categories/'+url+'/content')
        req.add_header('User-Agent', UA)
        req.add_header('Referer', 'https://tubitv.com/')
        opener = urllib2.build_opener()
        f = opener.open(req)
        jsonrsp = json.loads(f.read())
        #print jsonrsp[0]['n']
        #print jsonrsp[0]['i']
        #print jsonrsp[0]['t']
        #print str(jsonrsp[0]['s'])
        #print jsonrsp[0]['pp']
        
        #Начало на обхождането
        for movie in range(0, len(jsonrsp)):
            try:
                if jsonrsp[movie]['type'] == 'v': #Ако е игрален филм
                    addLink(jsonrsp[movie]['title'],jsonrsp[movie]['id'],str(jsonrsp[movie]['duration']),3,'http:'+jsonrsp[movie]['posterarts'][0])
                elif jsonrsp[movie]['type'] == 's': #Ако е сериал
                    addDir(jsonrsp[movie]['title'],jsonrsp[movie]['id'],4,'http:'+jsonrsp[movie]['posterarts'][0])
            except:
                pass
        #Край на обхождането
        
        
        
#Разлистване заглавията от търсенето
def SEARCHCONTENT(url):
        req = urllib2.Request(url)
        req.add_header('User-Agent', UA)
        req.add_header('Referer', 'http://tubitv.com/')
        opener = urllib2.build_opener()
        f = opener.open(req)
        jsonrsp = json.loads(f.read())
        
        #Начало на обхождането
        for movie in range(0, len(jsonrsp)):
            try:
                if jsonrsp[movie]['type'] == 'v': #Ако е игрален филм
                    addLink(jsonrsp[movie]['title'],jsonrsp[movie]['id'],str(jsonrsp[movie]['duration']),3,'http:'+jsonrsp[movie]['posterarts'][0])
                elif jsonrsp[movie]['type'] == 's': #Ако е сериал
                    addDir(jsonrsp[movie]['title'],jsonrsp[movie]['id'],4,'http:'+jsonrsp[movie]['posterarts'][0])
            except:
                pass
        #Край на обхождането





#Разлистване епизодите на сериал
def EPISODES(url):
        req = urllib2.Request('http://tubitv.com/oz/videos/0'+url+'/content')
        req.add_header('User-Agent', UA)
        req.add_header('Referer', 'http://tubitv.com/')
        opener = urllib2.build_opener()
        f = opener.open(req)
        jsonrsp = json.loads(f.read())
        #print jsonrsp['k'][0]
        
        #Начало на обхождането
        for season in range(0, len(jsonrsp['children'])):
            for episode in range(0, len(jsonrsp['children'][season]['children'])):
                try:
                    addLink(jsonrsp['children'][season]['children'][episode]['title'],jsonrsp['children'][season]['children'][episode]['id'],str(jsonrsp['children'][season]['children'][episode]['duration']),3,'http:'+jsonrsp['children'][season]['children'][episode]['thumbnails'][0])
                except:
                    pass
        #Край на обхождането





#Търсачка
def SEARCH(url):
        keyb = xbmc.Keyboard('', 'Search in TUBI Database')
        keyb.doModal()
        searchText = ''
        if (keyb.isConfirmed()):
            searchText = urllib.quote_plus(keyb.getText())
            searchText=searchText.replace(' ','+')
            searchurl = url + searchText
            searchurl = searchurl.encode('utf-8')
            SEARCHCONTENT(searchurl)
        else:
            addDir('Go to main menu...','','',"DefaultFolderBack.png")







#Зареждане на видео
def PLAY(name,url,iconimage):
        req = urllib2.Request('http://tubitv.com/oz/videos/'+url+'/content')
        req.add_header('User-Agent', UA)
        req.add_header('Referer', 'http://tubitv.com/')
        opener = urllib2.build_opener()
        f = opener.open(req)
        jsonrsp = json.loads(f.read())
        #print jsonrsp['url']
        
        #Изтегляне на субтитри
        suburl=''
        try:
            suburl=jsonrsp['subtitles'][0]['url']
            req = urllib2.Request('http:'+suburl)
            req.add_header('User-Agent', UA)
            response = urllib2.urlopen(req)
            data=response.read()
            response.close()
            with open(srtsubs_path, "w") as subfile:
                subfile.write(data)
                sub = 'true'
                xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%('TUBI','Loaded English subtitles', 4000, 'DefaultAddonSubtitles.png'))
        except:
            sub = 'false'
        
        
        li = xbmcgui.ListItem(iconImage=iconimage, thumbnailImage=iconimage, path='http:'+jsonrsp['url']+'|User-Agent=stagefright&X-Forwarded-For=52.9.185.254')
        li.setInfo('video', { 'title': name })
        try:
            xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, xbmcgui.ListItem(path = 'http:'+jsonrsp['url']+'|User-Agent=stagefright&X-Forwarded-For=52.9.185.254'))
        except:
            xbmc.executebuiltin("Notification('Грешка','Видеото липсва на сървъра!')")
        
        #Задаване на субтитри, ако има такива или изключването им
        if sub=='true':
            while not xbmc.Player().isPlaying():
                xbmc.sleep(2000) #wait until video is being played
                xbmc.Player().setSubtitles(srtsubs_path)
        else:
            xbmc.Player().showSubtitles(False)






#Модул за добавяне на отделно заглавие и неговите атрибути към съдържанието на показваната в Kodi директория - НЯМА НУЖДА ДА ПРОМЕНЯТЕ НИЩО ТУК
def addLink(name,url,vd,mode,iconimage):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name } )
        liz.addStreamInfo('video', { 'codec': 'h264', 'width': 1280, 'height': 720, 'duration': vd })
        liz.setProperty("IsPlayable" , "true")
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
        return ok

#Модул за добавяне на отделна директория и нейните атрибути към съдържанието на показваната в Kodi директория - НЯМА НУЖДА ДА ПРОМЕНЯТЕ НИЩО ТУК
def addDir(name,url,mode,iconimage):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name } )
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=True)
        return ok


#НЯМА НУЖДА ДА ПРОМЕНЯТЕ НИЩО ТУК
def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
                params=sys.argv[2]
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param



params=get_params()
url=None
name=None
iconimage=None
mode=None

try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        name=urllib.unquote_plus(params["iconimage"])
except:
        pass
try:
        mode=int(params["mode"])
except:
        pass


#Списък на отделните подпрограми/модули в тази приставка - трябва напълно да отговаря на кода отгоре
if mode==None or url==None or len(url)<1:
        CATEGORIES()
    
elif mode==1:
        INDEXCONTENT(url)

elif mode==2:
        SEARCH(url)

elif mode==3:
        PLAY(name,url,iconimage)

elif mode==4:
        EPISODES(url)

elif mode==5:
        SEARCHCONTENT(url)


xbmcplugin.endOfDirectory(int(sys.argv[1]))
